diff --git a/storage/innobase/read/read0read.cc b/storage/innobase/read/read0read.cc
index f5b6ff9..c543929 100644
--- a/storage/innobase/read/read0read.cc
+++ b/storage/innobase/read/read0read.cc
@@ -182,6 +182,7 @@ will mark their views as closed but not actually free their views.
 /** Minimum number of elements to reserve in ReadView::ids_t */
 static const ulint MIN_TRX_IDS = 32;
 
+#ifndef HAVE_LOCK_FREE_READVIEW
 #ifdef UNIV_DEBUG
 /** Functor to validate the view list. */
 struct ViewCheck {
@@ -322,12 +323,24 @@ ReadView::ReadView()
   ut_d(m_view_low_limit_no = 0);
 }
 
+#else
+/**
+ReadView constructor */
+ReadView::ReadView()
+    : m_low_limit_id(),
+      m_up_limit_id(),
+      m_creator_trx_id(),
+      m_low_limit_no(),
+      m_state(READ_VIEW_STATE_CLOSED) {}
+#endif /* HAVE_LOCK_FREE_READVIEW */
+
 /**
 ReadView destructor */
 ReadView::~ReadView() {
   // Do nothing
 }
 
+#ifndef HAVE_LOCK_FREE_READVIEW
 /** Constructor
 @param size		Number of views to pre-allocate */
 MVCC::MVCC(ulint size) {
@@ -745,3 +758,122 @@ void MVCC::set_view_creator_trx_id(ReadView *view, trx_id_t id) {
 
   view->creator_trx_id(id);
 }
+#endif /* HAVE_LOCK_FREE_READVIEW */
+
+#ifdef HAVE_LOCK_FREE_READVIEW
+void ReadView::copy(const ReadView &other) {
+  ut_ad(&other != this);
+  if (m_low_limit_no > other.m_low_limit_no) {
+    m_low_limit_no = other.m_low_limit_no;
+  }
+  if (m_low_limit_id > other.m_low_limit_id) {
+    m_low_limit_id = other.m_low_limit_id;
+  }
+
+  auto dst = m_ids.begin();
+  for (auto id : other.m_ids) {
+    if (id >= m_low_limit_id) {
+      break;
+    }
+
+  loop:
+    if (dst == m_ids.end()) {
+      m_ids.push_back(id);
+      dst = m_ids.end();
+      continue;
+    }
+    if (*dst < id) {
+      dst++;
+      goto loop;
+    } else if (*dst > id) {
+      dst = m_ids.insert(dst, id) + 1;
+    }
+  }
+  m_ids.erase(std::lower_bound(dst, m_ids.end(), m_low_limit_id), m_ids.end());
+
+  m_up_limit_id = m_ids.empty() ? m_low_limit_id : m_ids.front();
+  ut_ad(m_up_limit_id <= m_low_limit_id);
+}
+
+/** Creates a snapshot where exactly the transaction serialized before this
+point in time are seen in the view.
+
+@param[in,out] trx transaction */
+void ReadView::snapshot(trx_t *trx) {
+  trx_sys->snapshot_ids(trx, &m_ids, &m_low_limit_id, &m_low_limit_no);
+  std::sort(m_ids.begin(), m_ids.end());
+  m_up_limit_id = m_ids.empty() ? m_low_limit_id : m_ids.front();
+  ut_ad(m_up_limit_id <= m_low_limit_id);
+}
+
+/** Open a read view where exactly the transactions serialized before this point
+in time are seen in the view.
+
+View becomes visible to purge thread.
+
+@param[in,out] trx transaction*/
+void ReadView::open(trx_t *trx) {
+  ut_ad(this == &trx->read_view);
+  switch (m_state.load(std::memory_order_relaxed)) {
+    case READ_VIEW_STATE_OPEN:
+      ut_ad(!srv_read_only_mode);
+      return;
+    case READ_VIEW_STATE_CLOSED:
+      if (srv_read_only_mode) {
+        return;
+      }
+      /* Reuse closed view if there were no read-write transactions since (and
+      at) its creation time.
+
+      Original comment states: there is an inherent race between purge and this
+      thread.
+
+      To avoid this race we should've checked trx_sys->get_max_trx_id() and set
+      state to READ_VIEW_STATE_OPEN atomically under trx_sys->mutex protection.
+      But we'are cutting edges to achieve greate scalability.
+
+      There's at least two types of concurrent threads interested in this value:
+      purge coordinator thread (sees trx_sys_t::clone_oldest_view()) and InnoDB
+      monitor thread (see lock_trx_print_wait_and_mvcc_state()).
+
+      What bad things can happen because we allow this race?
+
+      Speculative execution may reorder state change before get_max_trx_id(). In
+      this case purge thread has short gap to clone outdated view. Which is
+      probably not that bad: it just won't be able to purge things that it was
+      actually allowed to purge for a short while.
+
+      This thread may as well get suspended after trx_sys->get_max_trx_id() and
+      before state is set to READ_VIEW_STATE_OPEN. New read-write transaction
+      may get started, committed and purged meanwhile. It is acceptable as well,
+      since this view doesn't see it. */
+      if (trx_is_autocommit_non_locking(trx) && m_ids.empty() &&
+          m_low_limit_id == trx_sys->get_max_trx_id()) {
+        goto reopen;
+      }
+
+      /* Can't reuse view, take new snapshot.
+
+      Alas this empty critical section is simplest way to make sure concurrent
+      purge thread completed snapshot copy. Of course purge thread may come
+      again and try to copy once again after we release this mutex, but in this
+      case it is guaranteed to see READ_VIEW_STATE_REGISTERED and thus it'll
+      skip this view.
+
+      This critical section can be replaced with new state, which purge thread
+      would set to inform us to wait until it completes snapshot. However it'd
+      complicate m_state even further. */
+      mutex_enter(&trx_sys->mutex);
+      mutex_exit(&trx_sys->mutex);
+      m_state.store(READ_VIEW_STATE_SNAPSHOT, std::memory_order_relaxed);
+      break;
+    default:
+      ut_ad(false);
+  }
+
+  snapshot(trx);
+reopen:
+  m_creator_trx_id = trx->id;
+  m_state.store(READ_VIEW_STATE_OPEN, std::memory_order_release);
+}
+#endif /* HAVE_LOCK_FREE_READVIEW */
diff --git a/storage/innobase/row/row0ins.cc b/storage/innobase/row/row0ins.cc
index 20ac667..3a7c5c3 100644
--- a/storage/innobase/row/row0ins.cc
+++ b/storage/innobase/row/row0ins.cc
@@ -706,7 +706,9 @@ static void row_ins_foreign_trx_print(trx_t *trx) /*!< in: transaction */
   heap_size = mem_heap_get_size(trx->lock.lock_heap);
   lock_mutex_exit();
 
+#ifndef HAVE_LOCK_FREE_READVIEW
   trx_sys_mutex_enter();
+#endif /* HAVE_LOCK_FREE_READVIEW */
 
   mutex_enter(&dict_foreign_err_mutex);
   rewind(dict_foreign_err_file);
@@ -716,7 +718,9 @@ static void row_ins_foreign_trx_print(trx_t *trx) /*!< in: transaction */
   trx_print_low(dict_foreign_err_file, trx, 600, n_rec_locks, n_trx_locks,
                 heap_size);
 
+#ifndef HAVE_LOCK_FREE_READVIEW
   trx_sys_mutex_exit();
+#endif /* HAVE_LOCK_FREE_READVIEW */
 
   ut_ad(mutex_own(&dict_foreign_err_mutex));
 }
diff --git a/storage/innobase/row/row0merge.cc b/storage/innobase/row/row0merge.cc
index a4394b5..06507cd 100644
--- a/storage/innobase/row/row0merge.cc
+++ b/storage/innobase/row/row0merge.cc
@@ -1915,6 +1915,24 @@ static MY_ATTRIBUTE((warn_unused_result)) dberr_t
       ONLINE_INDEX_COMPLETE state between the time
       the DML thread has updated the clustered index
       but has not yet accessed secondary index. */
+#ifdef HAVE_LOCK_FREE_READVIEW
+      ut_ad(trx->read_view.is_open());
+
+      if (!trx->read_view.changes_visible(
+              row_get_rec_trx_id(rec, clust_index, offsets), old_table->name)) {
+        rec_t *old_vers;
+
+        row_vers_build_for_consistent_read(rec, &mtr, clust_index, &offsets,
+                                           &trx->read_view, &row_heap, row_heap,
+                                           &old_vers, nullptr, nullptr);
+
+        rec = old_vers;
+
+        if (rec == nullptr) {
+          continue;
+        }
+      }
+#else
       ut_ad(MVCC::is_view_active(trx->read_view));
 
       if (!trx->read_view->changes_visible(
@@ -1931,6 +1949,7 @@ static MY_ATTRIBUTE((warn_unused_result)) dberr_t
           continue;
         }
       }
+#endif /* HAVE_LOCK_FREE_READVIEW */
 
       if (rec_get_deleted_flag(rec, dict_table_is_comp(old_table))) {
         /* This record was deleted in the latest
diff --git a/storage/innobase/row/row0mysql.cc b/storage/innobase/row/row0mysql.cc
index 3188afb..a352401 100644
--- a/storage/innobase/row/row0mysql.cc
+++ b/storage/innobase/row/row0mysql.cc
@@ -4658,7 +4658,11 @@ dberr_t row_scan_index_for_mysql(row_prebuilt_t *prebuilt, dict_index_t *index,
       /* No INSERT INTO  ... SELECT  and non-locking selects only. */
       trx_start_if_not_started_xa(prebuilt->trx, false);
 
+#ifdef HAVE_LOCK_FREE_READVIEW
+      prebuilt->trx->read_view.open(prebuilt->trx);
+#else
       trx_assign_read_view(prebuilt->trx);
+#endif /* HAVE_LOCK_FREE_READVIEW */
 
       auto trx = prebuilt->trx;
 
diff --git a/storage/innobase/row/row0pread.cc b/storage/innobase/row/row0pread.cc
index 3105cad..3660db8 100644
--- a/storage/innobase/row/row0pread.cc
+++ b/storage/innobase/row/row0pread.cc
@@ -334,10 +334,17 @@ bool Parallel_reader::Scan_ctx::check_visibility(const rec_t *&rec,
                                                  mtr_t *mtr) {
   const auto table_name = m_config.m_index->table->name;
 
+#ifndef HAVE_LOCK_FREE_READVIEW
   ut_ad(m_trx->read_view == nullptr || MVCC::is_view_active(m_trx->read_view));
+#endif /* HAVE_LOCK_FREE_READVIEW */
 
+#ifdef HAVE_LOCK_FREE_READVIEW
+  if (m_trx->read_view.is_open()) {
+    ReadView* view = const_cast<ReadView*>(&m_trx->read_view);
+#else
   if (m_trx->read_view != nullptr) {
     auto view = m_trx->read_view;
+#endif /* HAVE_LOCK_FREE_READVIEW */
 
     if (m_config.m_index->is_clustered()) {
       trx_id_t rec_trx_id;
diff --git a/storage/innobase/row/row0row.cc b/storage/innobase/row/row0row.cc
index edf01a4..3a7a4d6 100644
--- a/storage/innobase/row/row0row.cc
+++ b/storage/innobase/row/row0row.cc
@@ -376,6 +376,7 @@ static inline dtuple_t *row_build_low(ulint type, const dict_index_t *index,
   ut_ad(heap != NULL);
   ut_ad(index->is_clustered());
   ut_ad(!trx_sys_mutex_own());
+
   ut_ad(!col_map || col_table);
 
   if (!offsets) {
@@ -385,6 +386,11 @@ static inline dtuple_t *row_build_low(ulint type, const dict_index_t *index,
   }
 
 #if defined UNIV_DEBUG || defined UNIV_BLOB_LIGHT_DEBUG
+#ifdef HAVE_LOCK_FREE_READVIEW
+  ut_a(!rec_offs_any_null_extern(rec, offsets) ||
+       trx_sys->is_registered(current_trx(),
+                              row_get_rec_trx_id(rec, index, offsets)));
+#else
   /* Some blob refs can be NULL during crash recovery before
   trx_rollback_active() has completed execution, or when a concurrently
   executing insert or update has committed the B-tree mini-transaction
@@ -394,6 +400,7 @@ static inline dtuple_t *row_build_low(ulint type, const dict_index_t *index,
   insert or update statement.  */
   ut_a(!rec_offs_any_null_extern(rec, offsets) ||
        trx_rw_is_active(row_get_rec_trx_id(rec, index, offsets), NULL, false));
+#endif /* HAVE_LOCK_FREE_READVIEW */
 #endif /* UNIV_DEBUG || UNIV_BLOB_LIGHT_DEBUG */
 
   if (type != ROW_COPY_POINTERS) {
diff --git a/storage/innobase/row/row0sel.cc b/storage/innobase/row/row0sel.cc
index ede4d37..07f3e63 100644
--- a/storage/innobase/row/row0sel.cc
+++ b/storage/innobase/row/row0sel.cc
@@ -751,9 +751,15 @@ static void row_sel_build_committed_vers_for_mysql(
     prebuilt->old_vers_heap = mem_heap_create(rec_offs_size(*offsets));
   }
 
+#ifdef HAVE_LOCK_FREE_READVIEW
+  row_vers_build_for_semi_consistent_read(
+      prebuilt->trx, rec, mtr, clust_index, offsets, offset_heap,
+      prebuilt->old_vers_heap, old_vers, vrow);
+#else
   row_vers_build_for_semi_consistent_read(rec, mtr, clust_index, offsets,
                                           offset_heap, prebuilt->old_vers_heap,
                                           old_vers, vrow);
+#endif /* HAVE_LOCK_FREE_READVIEW */
 }
 
 /** Tests the conditions which determine when the index segment we are searching
@@ -2165,6 +2171,16 @@ que_thr_t *row_sel_step(que_thr_t *thr) /*!< in: query thread */
 
     if (node->consistent_read) {
       /* Assign a read view for the query */
+#ifdef HAVE_LOCK_FREE_READVIEW
+      trx_t *trx = thr_get_trx(thr);
+      trx->read_view.open(trx);
+
+      if (trx->read_view.is_open()) {
+        node->read_view = &trx->read_view;
+      } else {
+        node->read_view = nullptr;
+      }
+#else
       trx_assign_read_view(thr_get_trx(thr));
 
       if (thr_get_trx(thr)->read_view != NULL) {
@@ -2172,6 +2188,7 @@ que_thr_t *row_sel_step(que_thr_t *thr) /*!< in: query thread */
       } else {
         node->read_view = NULL;
       }
+#endif /* HAVE_LOCK_FREE_READVIEW */
 
     } else {
       sym_node_t *table_node;
@@ -3346,9 +3363,15 @@ dberr_t Row_sel_get_clust_rec_for_mysql::operator()(
                                        trx_get_read_view(trx))) {
       if (clust_rec != cached_clust_rec) {
         /* The following call returns 'offsets' associated with 'old_vers' */
+#ifdef HAVE_LOCK_FREE_READVIEW
+        err = row_sel_build_prev_vers_for_mysql(
+            &trx->read_view, clust_index, prebuilt, clust_rec, offsets,
+            offset_heap, &old_vers, vrow, mtr, lob_undo);
+#else
         err = row_sel_build_prev_vers_for_mysql(
             trx->read_view, clust_index, prebuilt, clust_rec, offsets,
             offset_heap, &old_vers, vrow, mtr, lob_undo);
+#endif /* HAVE_LOCK_FREE_READVIEW */
 
         if (err != DB_SUCCESS) {
           goto err_exit;
@@ -4644,7 +4667,12 @@ dberr_t row_search_mvcc(byte *buf, page_cur_mode_t mode,
     if (trx->mysql_n_tables_locked == 0 && !prebuilt->ins_sel_stmt &&
         prebuilt->select_lock_type == LOCK_NONE &&
         trx->isolation_level > TRX_ISO_READ_UNCOMMITTED &&
-        MVCC::is_view_active(trx->read_view)) {
+#ifdef HAVE_LOCK_FREE_READVIEW
+        trx->read_view.is_open())
+#else
+        MVCC::is_view_active(trx->read_view))
+#endif /* HAVE_LOCK_FREE_READVIEW */
+    {
       /* This is a SELECT query done as a consistent read,
       and the read view has already been allocated:
       let us try a search shortcut through the hash
@@ -4753,8 +4781,13 @@ dberr_t row_search_mvcc(byte *buf, page_cur_mode_t mode,
 
   ut_ad(!trx_is_started(trx) || trx->state == TRX_STATE_ACTIVE);
 
+#ifdef HAVE_LOCK_FREE_READVIEW
+  ut_ad(prebuilt->sql_stat_start || prebuilt->select_lock_type != LOCK_NONE ||
+        trx->read_view.is_open() || srv_read_only_mode);
+#else
   ut_ad(prebuilt->sql_stat_start || prebuilt->select_lock_type != LOCK_NONE ||
         MVCC::is_view_active(trx->read_view) || srv_read_only_mode);
+#endif /* HAVE_LOCK_FREE_READVIEW */
 
   trx_start_if_not_started(trx, false);
 
@@ -4797,6 +4830,17 @@ dberr_t row_search_mvcc(byte *buf, page_cur_mode_t mode,
   if (!prebuilt->sql_stat_start) {
     /* No need to set an intention lock or assign a read view */
 
+#ifdef HAVE_LOCK_FREE_READVIEW
+    if (!trx->read_view.is_open() && !srv_read_only_mode &&
+        prebuilt->select_lock_type == LOCK_NONE) {
+      ib::error(ER_IB_MSG_1031) << "MySQL is trying to perform a"
+                                   " consistent read but the read view is not"
+                                   " assigned!";
+      trx_print(stderr, trx, 600);
+      fputc('\n', stderr);
+      ut_error;
+    }
+#else
     if (!MVCC::is_view_active(trx->read_view) && !srv_read_only_mode &&
         prebuilt->select_lock_type == LOCK_NONE) {
       ib::error(ER_IB_MSG_1031) << "MySQL is trying to perform a"
@@ -4806,12 +4850,17 @@ dberr_t row_search_mvcc(byte *buf, page_cur_mode_t mode,
       fputc('\n', stderr);
       ut_error;
     }
+#endif /* HAVE_LOCK_FREE_READVIEW */
   } else if (prebuilt->select_lock_type == LOCK_NONE) {
     /* This is a consistent read */
     /* Assign a read view for the query */
 
     if (!srv_read_only_mode) {
+#ifdef HAVE_LOCK_FREE_READVIEW
+      trx->read_view.open(trx);
+#else
       trx_assign_read_view(trx);
+#endif /* HAVE_LOCK_FREE_READVIEW */
     }
 
     prebuilt->sql_stat_start = FALSE;
@@ -5315,10 +5364,17 @@ rec_loop:
                                          trx_get_read_view(trx))) {
         rec_t *old_vers;
         /* The following call returns 'offsets' associated with 'old_vers' */
+#ifdef HAVE_LOCK_FREE_READVIEW
+        err = row_sel_build_prev_vers_for_mysql(
+            &trx->read_view, clust_index, prebuilt, rec, &offsets, &heap,
+            &old_vers, need_vrow ? &vrow : nullptr, &mtr,
+            prebuilt->get_lob_undo());
+#else
         err = row_sel_build_prev_vers_for_mysql(
             trx->read_view, clust_index, prebuilt, rec, &offsets, &heap,
             &old_vers, need_vrow ? &vrow : NULL, &mtr,
             prebuilt->get_lob_undo());
+#endif /* HAVE_LOCK_FREE_READVIEW */
 
         if (err != DB_SUCCESS) {
           goto lock_wait_or_error;
@@ -5343,8 +5399,14 @@ rec_loop:
 
       ut_ad(!index->is_clustered());
 
+#ifdef HAVE_LOCK_FREE_READVIEW
+      if (!srv_read_only_mode &&
+          !lock_sec_rec_cons_read_sees(rec, index, &trx->read_view))
+#else
       if (!srv_read_only_mode &&
-          !lock_sec_rec_cons_read_sees(rec, index, trx->read_view)) {
+          !lock_sec_rec_cons_read_sees(rec, index, trx->read_view))
+#endif /* HAVE_LOCK_FREE_READVIEW */
+        {
         /* We should look at the clustered index.
         However, as this is a non-locking read,
         we can skip the clustered index lookup if
diff --git a/storage/innobase/row/row0upd.cc b/storage/innobase/row/row0upd.cc
index 5e950b2..ac7aa5f 100644
--- a/storage/innobase/row/row0upd.cc
+++ b/storage/innobase/row/row0upd.cc
@@ -3054,8 +3054,14 @@ static MY_ATTRIBUTE((warn_unused_result)) dberr_t
     }
   }
 
+#ifdef HAVE_LOCK_FREE_READVIEW
+  ut_ad((row_get_rec_trx_id(rec, index, offsets) == trx->id) ||
+        lock_trx_has_rec_x_lock(thr, index->table, btr_pcur_get_block(pcur),
+                                page_rec_get_heap_no(rec)));
+#else
   ut_ad(lock_trx_has_rec_x_lock(thr, index->table, btr_pcur_get_block(pcur),
                                 page_rec_get_heap_no(rec)));
+#endif /* HAVE_LOCK_FREE_READVIEW */
 
   /* NOTE: the following function calls will also commit mtr */
 
diff --git a/storage/innobase/row/row0vers.cc b/storage/innobase/row/row0vers.cc
index 42ab246..6a4b322 100644
--- a/storage/innobase/row/row0vers.cc
+++ b/storage/innobase/row/row0vers.cc
@@ -228,6 +228,9 @@ looking_for_match to the given sec_rec is found among versions created by trx_id
 or the one version before them
 */
 static bool row_vers_find_matching(
+#ifdef HAVE_LOCK_FREE_READVIEW
+    trx_t *caller_trx, /*!< in/out: trx of current thread */
+#endif                 /* HAVE_LOCK_FREE_READVIEW */
     bool looking_for_match, const dict_index_t *const clust_index,
     const rec_t *const clust_rec, ulint *&clust_offsets,
     const dict_index_t *const sec_index, const rec_t *const sec_rec,
@@ -255,8 +258,13 @@ static bool row_vers_find_matching(
     /* The oldest visible clustered index version must not be
     delete-marked, because we never start a transaction by
     inserting a delete-marked record. */
+#ifdef HAVE_LOCK_FREE_READVIEW
+    ut_ad(prev_version != nullptr || rec_get_deleted_flag(version, comp) == 0 ||
+          !trx_sys->is_registered(caller_trx, trx_id));
+#else
     ut_ad(prev_version || !rec_get_deleted_flag(version, comp) ||
           !trx_rw_is_active(trx_id, NULL, false));
+#endif /* HAVE_LOCK_FREE_READVIEW */
 
     /* Free version and clust_offsets. */
     mem_heap_free(old_heap);
@@ -289,6 +297,9 @@ static bool row_vers_find_matching(
  trx_is_active() while holding lock_sys->mutex. */
 UNIV_INLINE
 trx_t *row_vers_impl_x_locked_low(
+#ifdef HAVE_LOCK_FREE_READVIEW
+    trx_t *caller_trx,         /*!< in/out: trx of current thread */
+#endif                         /* HAVE_LOCK_FREE_READVIEW */
     const rec_t *const clust_rec,          /*!< in: clustered index record */
     const dict_index_t *const clust_index, /*!< in: the clustered index */
     const rec_t *const sec_rec,            /*!< in: secondary index record */
@@ -496,6 +507,26 @@ trx_t *row_vers_impl_x_locked_low(
   trx_id = row_get_rec_trx_id(clust_rec, clust_index, clust_offsets);
   corrupt = FALSE;
 
+#ifdef HAVE_LOCK_FREE_READVIEW
+  trx_t *trx;
+
+  if (trx_id == caller_trx->id) {
+    trx = caller_trx;
+    trx->reference();
+  } else {
+    trx = trx_sys->find(caller_trx, trx_id);
+    if (trx == nullptr) {
+      /* The transaction that modified or inserted clust_rec is no
+      longer active, or it is corrupt: no implicit lock on rec */
+      if (corrupt != 0u) {
+        lock_report_trx_id_insanity(trx_id, clust_rec, clust_index,
+                                    clust_offsets, trx_sys->get_max_trx_id());
+      }
+      mem_heap_free(heap);
+      return 0;
+    }
+  }
+#else
   trx_t *trx = trx_rw_is_active(trx_id, &corrupt, true);
 
   if (trx == 0) {
@@ -508,6 +539,7 @@ trx_t *row_vers_impl_x_locked_low(
     mem_heap_free(heap);
     return 0;
   }
+#endif /* HAVE_LOCK_FREE_READVIEW */
 
   comp = page_rec_is_comp(sec_rec);
   ut_ad(sec_index->table == clust_index->table);
@@ -516,10 +548,17 @@ trx_t *row_vers_impl_x_locked_low(
 
   bool looking_for_match = rec_get_deleted_flag(sec_rec, comp);
 
+#ifdef HAVE_LOCK_FREE_READVIEW
+  if (!row_vers_find_matching(caller_trx, looking_for_match, clust_index,
+                              clust_rec, clust_offsets, sec_index, sec_rec,
+                              sec_offsets, comp, trx_id, mtr, heap)) {
+    trx->release_reference();
+#else
   if (!row_vers_find_matching(looking_for_match, clust_index, clust_rec,
                               clust_offsets, sec_index, sec_rec, sec_offsets,
                               comp, trx_id, mtr, heap)) {
     trx_release_reference(trx);
+#endif /* HAVE_LOCK_FREE_READVIEW */
     trx = 0;
   }
 
@@ -536,6 +575,9 @@ trx_t *row_vers_impl_x_locked_low(
  negatives. The caller must confirm all positive results by calling
  trx_is_active() while holding lock_sys->mutex. */
 trx_t *row_vers_impl_x_locked(
+#ifdef HAVE_LOCK_FREE_READVIEW
+    trx_t *caller_trx,    /*!< in/out: trx of current thread */
+#endif                    /* HAVE_LOCK_FREE_READVIEW */
     const rec_t *rec,          /*!< in: record in a secondary index */
     const dict_index_t *index, /*!< in: the secondary index */
     const ulint *offsets)      /*!< in: rec_get_offsets(rec, index) */
@@ -575,10 +617,17 @@ trx_t *row_vers_impl_x_locked(
 
     trx = 0;
   } else {
+#ifdef HAVE_LOCK_FREE_READVIEW
+    trx = row_vers_impl_x_locked_low(caller_trx, clust_rec, clust_index, rec,
+                                     index, offsets, &mtr);
+
+    ut_ad(trx == nullptr || trx->is_referenced());
+#else
     trx = row_vers_impl_x_locked_low(clust_rec, clust_index, rec, index,
                                      offsets, &mtr);
 
     ut_ad(trx == 0 || trx_is_referenced(trx));
+#endif /* HAVE_LOCK_FREE_READVIEW */
   }
 
   mtr_commit(&mtr);
@@ -1357,6 +1406,9 @@ dberr_t row_vers_build_for_consistent_read(
 /** Constructs the last committed version of a clustered index record,
  which should be seen by a semi-consistent read. */
 void row_vers_build_for_semi_consistent_read(
+#ifdef HAVE_LOCK_FREE_READVIEW
+    trx_t *caller_trx,        /*!< in/out: trx of current thread */
+#endif                        /* HAVE_LOCK_FREE_READVIEW */
     const rec_t *rec,         /*!< in: record in a clustered index; the
                               caller must have a latch on the page; this
                               latch locks the top of the stack of versions
@@ -1393,7 +1445,9 @@ void row_vers_build_for_semi_consistent_read(
   ut_ad(!vrow || !(*vrow));
 
   for (;;) {
+#ifndef HAVE_LOCK_FREE_READVIEW
     const trx_t *version_trx;
+#endif /* HAVE_LOCK_FREE_READVIEW */
     mem_heap_t *heap2;
     rec_t *prev_version;
     trx_id_t version_trx_id;
@@ -1403,6 +1457,9 @@ void row_vers_build_for_semi_consistent_read(
       rec_trx_id = version_trx_id;
     }
 
+#ifdef HAVE_LOCK_FREE_READVIEW
+    if (!trx_sys->is_registered(caller_trx, version_trx_id))
+#else
     trx_sys_mutex_enter();
     version_trx = trx_get_rw_trx_by_id(version_trx_id);
     /* Because version_trx is a read-write transaction,
@@ -1415,7 +1472,9 @@ void row_vers_build_for_semi_consistent_read(
     }
     trx_sys_mutex_exit();
 
-    if (!version_trx) {
+    if (!version_trx)
+#endif /* HAVE_LOCK_FREE_READVIEW */
+    {
     committed_version_trx:
       /* We found a version that belongs to a
       committed transaction: return it. */
diff --git a/storage/innobase/srv/srv0srv.cc b/storage/innobase/srv/srv0srv.cc
index 9592955..3ee3a68 100644
--- a/storage/innobase/srv/srv0srv.cc
+++ b/storage/innobase/srv/srv0srv.cc
@@ -1421,9 +1421,14 @@ ibool srv_printf_innodb_monitor(
           ULINTPF " queries inside InnoDB, " ULINTPF " queries in queue\n",
           srv_conc_get_active_threads(), srv_conc_get_waiting_threads());
 
+#ifdef HAVE_LOCK_FREE_READVIEW
+  fprintf(file, ULINTPF " read views open inside InnoDB\n",
+          trx_sys->view_count());
+#else
   /* This is a dirty read, without holding trx_sys->mutex. */
   fprintf(file, ULINTPF " read views open inside InnoDB\n",
           trx_sys->mvcc->size());
+#endif /* HAVE_LOCK_FREE_READVIEW */
 
   n_reserved = fil_space_get_n_reserved_extents(0);
   if (n_reserved > 0) {
@@ -1636,6 +1641,10 @@ void srv_export_innodb_status(void) {
 
   export_vars.innodb_undo_tablespaces_implicit = FSP_IMPLICIT_UNDO_TABLESPACES;
 
+#ifdef HAVE_LOCK_FREE_READVIEW
+  export_vars.innodb_have_lock_free_readview = TRUE;
+#endif
+
   undo::spaces->s_lock();
 
   export_vars.innodb_undo_tablespaces_total = undo::spaces->size();
@@ -1660,15 +1669,23 @@ void srv_export_innodb_status(void) {
   transaction number. We are allowed to purge transactions with number
   below the low limit. */
   ReadView oldest_view;
+#ifdef HAVE_LOCK_FREE_READVIEW
+  trx_sys->clone_oldest_view(&oldest_view);
+#else
   trx_sys->mvcc->clone_oldest_view(&oldest_view);
+#endif /* HAVE_LOCK_FREE_READVIEW */
   trx_id_t low_limit_no = oldest_view.view_low_limit_no();
 
   rw_lock_s_unlock(&purge_sys->latch);
 
+#ifdef HAVE_LOCK_FREE_READVIEW
+  trx_id_t max_trx_no = trx_sys->rw_max_trx_no;
+#else
   mutex_enter(&trx_sys->mutex);
   /* Maximum transaction number added to history list for purge. */
   trx_id_t max_trx_no = trx_sys->rw_max_trx_no;
   mutex_exit(&trx_sys->mutex);
+#endif /* HAVE_LOCK_FREE_READVIEW */
 
   if (done_trx_no == 0 || max_trx_no < done_trx_no) {
     export_vars.innodb_purge_trx_id_age = 0;
diff --git a/storage/innobase/srv/srv0start.cc b/storage/innobase/srv/srv0start.cc
index 9ed698d..c62f27f 100644
--- a/storage/innobase/srv/srv0start.cc
+++ b/storage/innobase/srv/srv0start.cc
@@ -1345,10 +1345,17 @@ dberr_t srv_undo_tablespaces_upgrade() {
   rsegs and undo tablespaces they are in from being deleted.
   These transactions must be either committed or rolled back by
   the mysql server.*/
+#ifdef HAVE_LOCK_FREE_READVIEW
+  if (trx_sys->found_prepared_trx()) {
+    ib::warn(ER_IB_MSG_1094);
+    return (DB_SUCCESS);
+  }
+#else
   if (trx_sys->n_prepared_trx > 0) {
     ib::warn(ER_IB_MSG_1094);
     return (DB_SUCCESS);
   }
+#endif /* HAVE_LOCK_FREE_READVIEW */
 
   ib::info(ER_IB_MSG_1095, trx_sys_undo_spaces->size(),
            ulong{FSP_IMPLICIT_UNDO_TABLESPACES});
@@ -2880,9 +2887,15 @@ void srv_dict_recover_on_restart() {
   that the data dictionary tables will be free of any locks.
   The data dictionary latch should guarantee that there is at
   most one data dictionary transaction active at a time. */
+#ifdef HAVE_LOCK_FREE_READVIEW
+  if (srv_force_recovery < SRV_FORCE_NO_TRX_UNDO) {
+    trx_rollback_recovered(false);
+  }
+#else
   if (srv_force_recovery < SRV_FORCE_NO_TRX_UNDO && trx_sys_need_rollback()) {
     trx_rollback_or_clean_recovered(FALSE);
   }
+#endif /* HAVE_LOCK_FREE_READVIEW */
 
   /* Do after all DD transactions recovery, to get consistent metadata */
   apply_dynamic_metadata();
@@ -2963,6 +2976,16 @@ void srv_start_threads(bool bootstrap) {
     return;
   }
 
+#ifdef HAVE_LOCK_FREE_READVIEW
+  if (!bootstrap && srv_force_recovery < SRV_FORCE_NO_TRX_UNDO) {
+    /* Rollback all recovered transactions that are
+    not in committed nor in XA PREPARE state. */
+    srv_threads.m_trx_recovery_rollback = os_thread_create(
+        trx_recovery_rollback_thread_key, trx_recovery_rollback_thread);
+
+    srv_threads.m_trx_recovery_rollback.start();
+  }
+#else
   if (!bootstrap && srv_force_recovery < SRV_FORCE_NO_TRX_UNDO &&
       trx_sys_need_rollback()) {
     /* Rollback all recovered transactions that are
@@ -2972,6 +2995,7 @@ void srv_start_threads(bool bootstrap) {
 
     srv_threads.m_trx_recovery_rollback.start();
   }
+#endif /* HAVE_LOCK_FREE_READVIEW */
 
   /* Create the master thread which does purge and other utility
   operations */
@@ -3096,7 +3120,11 @@ void srv_pre_dd_shutdown() {
     prepared transactions and we don't want to lose them. */
 
     for (uint32_t count = 0;; ++count) {
+#ifdef HAVE_LOCK_FREE_READVIEW
+      const ulint total_trx = trx_sys->any_active_transactions();
+#else
       const ulint total_trx = trx_sys_any_active_transactions();
+#endif
 
       if (total_trx == 0) {
         break;
@@ -3187,7 +3215,11 @@ void srv_pre_dd_shutdown() {
 
   srv_is_being_shutdown = true;
 
+#ifdef HAVE_LOCK_FREE_READVIEW
+  ut_a(trx_sys->any_active_transactions() == 0);
+#else
   ut_a(trx_sys_any_active_transactions() == 0);
+#endif
 
   DBUG_EXECUTE_IF("wait_for_threads_in_pre_dd_shutdown",
                   srv_shutdown_background_threads(););
@@ -3468,7 +3500,11 @@ void srv_shutdown() {
 
   ut_a(!srv_is_being_started);
   ut_a(srv_is_being_shutdown);
+#ifdef HAVE_LOCK_FREE_READVIEW
+  ut_a(trx_sys->any_active_transactions() == 0);
+#else
   ut_a(trx_sys_any_active_transactions() == 0);
+#endif
 
   /* Ensure threads below have been stopped. */
   const auto threads_stopped_before_shutdown = {
diff --git a/storage/innobase/sync/sync0debug.cc b/storage/innobase/sync/sync0debug.cc
index 0267a9a..675d3ed 100644
--- a/storage/innobase/sync/sync0debug.cc
+++ b/storage/innobase/sync/sync0debug.cc
@@ -444,6 +444,9 @@ LatchDebug::LatchDebug() {
   LEVEL_MAP_INSERT(SYNC_REC_LOCK);
   LEVEL_MAP_INSERT(SYNC_THREADS);
   LEVEL_MAP_INSERT(SYNC_TRX);
+#ifdef HAVE_LOCK_FREE_READVIEW
+  LEVEL_MAP_INSERT(SYNC_RW_TRX_HASH_ELEMENT);
+#endif /* HAVE_LOCK_FREE_READVIEW */
   LEVEL_MAP_INSERT(SYNC_TRX_SYS);
   LEVEL_MAP_INSERT(SYNC_LOCK_SYS);
   LEVEL_MAP_INSERT(SYNC_LOCK_WAIT_SYS);
@@ -481,6 +484,9 @@ LatchDebug::LatchDebug() {
   LEVEL_MAP_INSERT(SYNC_TABLE);
   LEVEL_MAP_INSERT(SYNC_STATS_AUTO_RECALC);
   LEVEL_MAP_INSERT(SYNC_DICT_AUTOINC_MUTEX);
+#ifdef HAVE_SCALABLE_LOCK_MGR
+  LEVEL_MAP_INSERT(SYNC_DICT_TABLE_LOCKS_MUTEX);
+#endif /* HAVE_SCALABLE_LOCK_MGR */
   LEVEL_MAP_INSERT(SYNC_DICT);
   LEVEL_MAP_INSERT(SYNC_PARSER);
   LEVEL_MAP_INSERT(SYNC_FTS_CACHE);
@@ -705,6 +711,9 @@ Latches *LatchDebug::check_order(const latch_t *latch,
     case SYNC_THREADS:
     case SYNC_LOCK_SYS:
     case SYNC_LOCK_WAIT_SYS:
+#ifdef HAVE_LOCK_FREE_READVIEW
+    case SYNC_RW_TRX_HASH_ELEMENT:
+#endif /* HAVE_LOCK_FREE_READVIEW */
     case SYNC_TRX_SYS:
     case SYNC_IBUF_BITMAP_MUTEX:
     case SYNC_TEMP_SPACE_RSEG:
@@ -1490,6 +1499,11 @@ static void sync_latch_meta_init() UNIV_NOTHROW {
 
   LATCH_ADD_MUTEX(TEST_MUTEX, SYNC_NO_ORDER_CHECK, PFS_NOT_INSTRUMENTED);
 
+#ifdef HAVE_LOCK_FREE_READVIEW
+  LATCH_ADD_MUTEX(RW_TRX_HASH_ELEMENT, SYNC_RW_TRX_HASH_ELEMENT,
+                  rw_trx_hash_element_mutex_key);
+#endif /* HAVE_LOCK_FREE_READVIEW */
+
   latch_id_t id = LATCH_ID_NONE;
 
   /* The array should be ordered on latch ID.We need to
diff --git a/storage/innobase/sync/sync0sync.cc b/storage/innobase/sync/sync0sync.cc
index 4330303..86bd999 100644
--- a/storage/innobase/sync/sync0sync.cc
+++ b/storage/innobase/sync/sync0sync.cc
@@ -125,6 +125,9 @@ mysql_pfs_key_t trx_pool_manager_mutex_key;
 mysql_pfs_key_t temp_pool_manager_mutex_key;
 mysql_pfs_key_t lock_mutex_key;
 mysql_pfs_key_t lock_wait_mutex_key;
+#ifdef HAVE_LOCK_FREE_READVIEW
+mysql_pfs_key_t rw_trx_hash_element_mutex_key;
+#endif /* HAVE_LOCK_FREE_READVIEW */
 mysql_pfs_key_t trx_sys_mutex_key;
 mysql_pfs_key_t srv_sys_mutex_key;
 mysql_pfs_key_t srv_threads_mutex_key;
